#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_person.py                                                        
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_person.py stellt Tools für die anderen absenzen-Module zur Verfügung
  Schwerpunkt: Anlegen und Verändern von Usern
________________________________________________________________________
'''

import a_tool, a_db, a_session as a_s, a_h, a_datum

def get_schueler(pid):
    return a_db.get_one_rowdict('SELECT * FROM personen WHERE pid=?',(pid,))
def get_name(pid):
    return a_db.get_first_element('SELECT name FROM personen WHERE pid=?',(pid,),'unbekannt')
    
def select_dialog():
    # Suche nach Schülern
    ausgabe=[]
    select=['<select name="mcpid">']
    select.append('\t<option>-</option>')
    for name,pid in a_db.get_rowdict_list('''
        SELECT name,pid 
        FROM personen 
        ORDER BY sortiername'''):
        select.append('\t<option value={}>{}</option>'.format(str(pid),name))
    select.append('</select>')
    ausgabe.append('''<div class="umrahmterhellt"><b>Einstellungen von Schüler(in)</b><form action="a_person.py" method="post" onsubmit="target_popup(this)">
        '''+'\n'.join(select)+'''<br>
        <input value="bearbeiten!" type="submit">
        <input name="pesid" value="'''+str(a_s.aS.sid)+'''" type="hidden"><br></form></div>''')
  
    select=['<select name="mcklasse">']
    select.append('\t<option>-</option>')
    for klasse in a_db.get_column_list('''
        SELECT name
        FROM klassen 
        ORDER BY js,name'''):
        select.append('\t<option value={}>{}</option>'.format(klasse,klasse))
    select.append('</select>')
    ausgabe.append('''<div class="umrahmterhellt"><b>Neue(n) Schüler(in)</b>
        <form action="a_person.py" method="post" onsubmit="target_popup(this)">
        in Klasse:'''+'\n'.join(select)+'''<br>
        <input name="neuerschueler" type="text" size="12" maxlength="20" />
        <input value="anlegen!" type="submit">
        <input name="pesid" value="'''+str(a_s.aS.sid)+'''" type="hidden"><br></form></div>''')
   
    ausgabe.append('''<div class="umrahmterhellt"><b>Mailcode zeigen:</b><br>
        Ablesen in den <i>Stammdaten</i><br>''')
    ausgabe.append('''<div class="gradientbuttons filelink" style="text-align:right">  <a href="a_main.py?popupaktion=schuelercodes" target="_blank" title="Öffnet sich in neuem Fenster">
            Schülercodes als csv-Datei</a><br>''')
    ausgabe.append('''  <a href="a_main.py?popupaktion=schuelerbrief" target="_blank" title="Öffnet sich in neuem Fenster">
            Serien-Mailcode-Brief</a></div></div>''')
    ausgabe.append('</div>')
    return '\n'.join(ausgabe)

def aendern_dialog():
    # Suche nach Schülern
    ausgabe=[]
    mcpid=a_tool.getcgiparameter('mcpid',neue_pid)
    try:
        schueler=get_schueler(mcpid)
        mcpname=schueler["name"]
    except:
        return "Kein Schüler ausgewählt - Schließen Sie das Fenster"
    
    ausgabe.append('''<b>Bearbeite {mcpn}:</b><br><br><form action="a_person.py" method="post" >
        <input value="Mailcode neu setzen!" type="submit">
        <input name="pesid" value="{pesid}" type="hidden">
        <input name="mcpid" value="{mcp}" type="hidden">
        <input name="mailcode" value="true" type="hidden">
        </form>'''.format(mcpn=mcpname,pesid=str(a_s.aS.sid),mcp=mcpid))
    ausgabe.append('''<form action="a_person.py" method="post" >
        <p>Eintrittsdatum: <input type="text" name="eintrittsdatum" class="datepicker" size="10" value="{e_pre}">
        <input value="setzen!" type="submit">
        <input name="pesid" value="{pesid}" type="hidden">
        <input name="mcpid" value="{mcp}" type="hidden"></p>
        </form>'''.format(pesid=str(a_s.aS.sid),mcp=mcpid,e_pre=a_datum.isodatum2datum(schueler["eintritt"],incaseoferror='ungesetzt')))
    ausgabe.append('''<form action="a_person.py" method="post" >
        <p>Austrittsdatum: <input type="text" name="austrittsdatum" class="datepicker" size="10" value="{a_pre}">
        <input value="setzen!" type="submit">
        <input name="pesid" value="{pesid}" type="hidden">
        <input name="mcpid" value="{mcp}" type="hidden"></p>
        </form>'''.format(pesid=str(a_s.aS.sid),mcp=mcpid,a_pre=a_datum.isodatum2datum(schueler["austritt"],incaseoferror='ungesetzt')))
    
    return '\n'.join(ausgabe)
    

def admin_doit(): # wird nur aufgerufen, wenn der User schon als Admin identifiziert wurde
    return doit()
    
def doit(): # kann auch von Klassleitern und Verwaltern aufgerufen werden
    global neue_pid
    ea_erfolg=''
    
    ## Neuer Schüler
    neuerschueler=a_tool.getcgiparameter('neuerschueler')
    seineklasse=a_tool.getcgiparameter('mcklasse')
    seinejs=a_db.get_first_element('SELECT js FROM klassen WHERE name=?',(seineklasse,))
    if len(neuerschueler)>2:
        if seinejs:
            dummy1,dummy2,pid=a_tool.schueler_eintragen(neuerschueler,'',seinejs,seineklasse)
            if pid>0:
                ea_erfolg+='+'+neuerschueler+' angelegt. '
                neue_pid=pid
            else:
                ea_erfolg+='-'+neuerschueler+' konnte nicht angelegt werden. '
        else: ea_erfolg+='-Es muss eine Klasse angegeben werden!'
    
    mcpid=a_tool.getcgiparameter('mcpid')
    if len(mcpid)>2:
        mcpname=get_name(mcpid)
        if a_tool.getcgiparameter("mailcode"):
            codeexistiert=True
            while codeexistiert:
                zugriffscode=a_tool.zufallscode()
                codeexistiert=a_db.get_existenz('''SELECT pid FROM personen WHERE zugriffscode=?''',(zugriffscode,))
            a_db.execute('''UPDATE personen SET zugriffscode=? WHERE pid=?''',(zugriffscode,mcpid))
            ea_erfolg+='+Neuer Code für '+mcpname+' lautet: '+zugriffscode+' (siehe StammdatenS)'
        eintritt=a_datum.datum2isodatum(a_tool.getcgiparameter("eintrittsdatum"),strict=True)
        if a_datum.ist_isodatum(eintritt):
            a_db.execute('UPDATE personen SET eintritt=? WHERE pid=?',(eintritt,mcpid))
            ea_erfolg+='+Eintrittsdatum von '+mcpname+' soll '+eintritt+' werden'
        austritt=a_datum.datum2isodatum(a_tool.getcgiparameter("austrittsdatum"),strict=True)
        if a_datum.ist_isodatum(austritt):
            a_db.execute('UPDATE personen SET austritt=? WHERE pid=?',(austritt,mcpid))
            ea_erfolg+='+Austrittsdatum von '+mcpname+' soll '+austritt+' werden'

    return ea_erfolg
    
neue_pid=0

if __name__ == '__main__':
    meldung="Unzulässiger Aufruf oder Session abgelaufen"
    pesid=a_tool.getcgiparameter("pesid")
    a_s.check_session()
    sid=str(a_s.get_session().sid)
    a_tool.print_file_start(head='<meta http-equiv="refresh" content="610; URL=a_person.py" />',
                            bodyextras='style="background:#DDD;padding:1em;"',mit_datepicker=True)
    resultat=''
    if pesid==sid:
        resultat=doit()
        a_tool.prt(a_h.erfolgsmeldung2html(resultat))
        a_tool.prt(aendern_dialog())
    else:
        a_tool.prt('<h1>'+meldung+'</h1>')
    a_tool.prt('</body>')

    
